
;----------------------------------------------------------------------
; Reads a file containing a console screen format into an array
; of structure CHAR_INFO totalling 8000 bytes, and invoke the API
; to display it all at once: WriteConsoleOutput(). Wait a key and
; terminates the program.
;----------------------------------------------------------------------
; Input file: myfile.txt
;----------------------------------------------------------------------
; Author: frktons @ MASM32 forum
; Date: 17/aug/2010. 
;---------------------------------------------------------------------- 


include \masm32\include\masm32rt.inc

Console80x25 PROTO


.data

        bytecount dd 8000 ; Bytes to read from input file
        ConTitle  db "Win32 Console 80 x 25 Fixed Size - Extended ASCII chart", 0     
         
        charArray CHAR_INFO 2000 dup (<>)
        lp_charArray  dd charArray[0]    

        hFile     HANDLE 0 


        wHnd      HANDLE 11 
        rHnd      HANDLE 10
        inpbyte   DWORD  1  

        windowSize SMALL_RECT <>
        bufferSize COORD      <>
        startPoint COORD      <>

.data?



.code
start:  

        mov hFile, fopen("myfiles.txt")

        mov ebx, fread(hFile, offset charArray, bytecount)

        fclose hFile

        invoke GetStdHandle, STD_OUTPUT_HANDLE
        mov    wHnd,eax

        mov windowSize.Left, 0
        mov windowSize.Right, 0
        mov windowSize.Top, 79
        mov windowSize.Bottom, 24
   

        mov bufferSize.x, 80
        mov bufferSize.y, 25

        mov startPoint.x, 0
        mov startPoint.y, 0

        invoke SetConsoleTitle, ADDR ConTitle
        

        invoke Console80x25

        invoke GetStdHandle, STD_INPUT_HANDLE
        mov rHnd,eax

        invoke ReadConsole, rHnd, ADDR inpbyte, 1, NULL, NULL

finish: invoke ExitProcess,0

        ret
   

Console80x25 PROC


    invoke SetConsoleWindowInfo, wHnd, TRUE, ADDR windowSize

    invoke SetConsoleScreenBufferSize, wHnd, DWORD PTR bufferSize

    invoke WriteConsoleOutput, wHnd, offset charArray, offset bufferSize, offset startPoint, offset windowSize 

    ret

Console80x25 ENDP


end start